/* tslint:disable */
/* eslint-disable */
/**
 * Ampli - A strong typed wrapper for your Analytics
 *
 * This file is generated by Amplitude.
 * To update run 'ampli pull integration-functions'
 *
 * Required dependencies: @amplitude/analytics-node@^0.5.0
 * Tracking Plan Version: 158
 * Build: 1.0.0
 * Runtime: node.js:typescript-ampli-v2
 *
 * [View Tracking Plan](https://data.amplitude.com/netlify-1232/Netlify/events/main/latest)
 *
 * [Full Setup Instructions](https://data.amplitude.com/netlify-1232/Netlify/implementation/integration-functions)
 */
import * as amplitude from '@amplitude/analytics-node';
export const ApiKey = {
    production: 'cebfd07e4b8bce591224aa2ab1e3e096',
    development: '60c433cd2d7a65ed140f33f250a840ea'
};
/**
* Default Amplitude configuration options. Contains tracking plan information.
*/
export const DefaultConfiguration = Object.assign({ plan: {
        version: '158',
        branch: 'main',
        source: 'integration-functions',
        versionId: '6bcddd98-85a5-41c2-881c-886939288c3e'
    } }, {
    ingestionMetadata: {
        sourceName: 'node.js-typescript-ampli',
        sourceVersion: '2.0.0'
    }
});
export class IntegrationEmailSend {
    constructor(event_properties) {
        this.event_properties = event_properties;
        this.event_type = 'integration:email-send';
        this.event_properties = event_properties;
    }
}
export class IntegrationSentryCronMonitoringEnabled {
    constructor(event_properties) {
        this.event_properties = event_properties;
        this.event_type = 'integration:sentry_cron_monitoring_enabled';
        this.event_properties = event_properties;
    }
}
export class IntegrationSentryEnabled {
    constructor(event_properties) {
        this.event_properties = event_properties;
        this.event_type = 'integration:sentry_enabled';
        this.event_properties = event_properties;
    }
}
const getVoidPromiseResult = () => ({ promise: Promise.resolve() });
// prettier-ignore
export class Ampli {
    constructor() {
        this.disabled = false;
    }
    get client() {
        this.isInitializedAndEnabled();
        return this.amplitude;
    }
    get isLoaded() {
        return this.amplitude != null;
    }
    isInitializedAndEnabled() {
        if (!this.amplitude) {
            console.error('ERROR: Ampli is not yet initialized. Have you called ampli.load() on app start?');
            return false;
        }
        return !this.disabled;
    }
    /**
     * Initialize the Ampli SDK. Call once when your application starts.
     *
     * @param options Configuration options to initialize the Ampli SDK with.
     */
    load(options) {
        var _a, _b;
        this.disabled = (_a = options.disabled) !== null && _a !== void 0 ? _a : false;
        if (this.amplitude) {
            console.warn('WARNING: Ampli is already initialized. Ampli.load() should be called once at application startup.');
            return getVoidPromiseResult();
        }
        let apiKey = null;
        if (options.client && 'apiKey' in options.client) {
            apiKey = options.client.apiKey;
        }
        else if ('environment' in options) {
            apiKey = ApiKey[options.environment];
        }
        if (options.client && 'instance' in options.client) {
            this.amplitude = options.client.instance;
        }
        else if (apiKey) {
            this.amplitude = amplitude.createInstance();
            return this.amplitude.init(apiKey, Object.assign(Object.assign({}, DefaultConfiguration), (_b = options.client) === null || _b === void 0 ? void 0 : _b.configuration));
        }
        else {
            console.error("ERROR: ampli.load() requires 'environment', 'client.apiKey', or 'client.instance'");
        }
        return getVoidPromiseResult();
    }
    /**
     * Identify a user and set user properties.
     *
     * @param userId The user's id.
     * @param options Optional event options.
     */
    identify(userId, options) {
        if (!this.isInitializedAndEnabled()) {
            return getVoidPromiseResult();
        }
        if (userId) {
            options = Object.assign(Object.assign({}, options), { user_id: userId });
        }
        const amplitudeIdentify = new amplitude.Identify();
        return this.amplitude.identify(amplitudeIdentify, options);
    }
    /**
     * Set Group for the user.
     *
     * @param userId The user's id.
     * @param groupType The group type.
     * @param groupName The group name.
     * @param options Optional event options.
     */
    setGroup(userId, groupType, groupName, options) {
        if (!this.isInitializedAndEnabled()) {
            return getVoidPromiseResult();
        }
        if (userId) {
            options = Object.assign(Object.assign({}, options), { user_id: userId });
        }
        return this.amplitude.setGroup(groupType, groupName, options);
    }
    /**
     * Identify a group and set group properties.
     *
     * @param groupType The group type.
     * @param groupName The group name.
     * @param options Optional event options.
     */
    groupIdentify(groupType, groupName, options) {
        if (!this.isInitializedAndEnabled()) {
            return getVoidPromiseResult();
        }
        const amplitudeIdentify = new amplitude.Identify();
        return this.amplitude.groupIdentify(groupType, groupName, amplitudeIdentify, options);
    }
    /**
     * Track event
     *
     * @param userId The user's id.
     * @param event The event to track.
     * @param options Optional event options.
     */
    track(userId, event, options) {
        if (!this.isInitializedAndEnabled()) {
            return getVoidPromiseResult();
        }
        if (userId) {
            options = Object.assign(Object.assign({}, options), { user_id: userId });
        }
        return this.amplitude.track(event, undefined, options);
    }
    flush() {
        if (!this.isInitializedAndEnabled()) {
            return getVoidPromiseResult();
        }
        return this.amplitude.flush();
    }
    /**
     * integration:email-send
     *
     * [View in Tracking Plan](https://data.amplitude.com/netlify-1232/Netlify/events/main/latest/integration%3Aemail-send)
     *
     * Owner: Ed Stephinson
     *
     * @param userId The user's ID.
     * @param properties The event's properties (e.g. provider)
     * @param options Amplitude event options.
     */
    integrationEmailSend(userId, properties, options) {
        return this.track(userId, new IntegrationEmailSend(properties), options);
    }
    /**
     * integration:sentry_cron_monitoring_enabled
     *
     * [View in Tracking Plan](https://data.amplitude.com/netlify-1232/Netlify/events/main/latest/integration%3Asentry_cron_monitoring_enabled)
     *
     * Tracks whether Sentry's Cron Monitoring feature is enabled for a Netlify Function. This should realistically only be used by Netlify Scheduled Functions
     *
     * Owner: erica.pisani@netlify.com
     *
     * @param userId The user's ID.
     * @param properties The event's properties (e.g. functionName)
     * @param options Amplitude event options.
     */
    integrationSentryCronMonitoringEnabled(userId, properties, options) {
        return this.track(userId, new IntegrationSentryCronMonitoringEnabled(properties), options);
    }
    /**
     * integration:sentry_enabled
     *
     * [View in Tracking Plan](https://data.amplitude.com/netlify-1232/Netlify/events/main/latest/integration%3Asentry_enabled)
     *
     * Tracks if Sentry is enabled for a given Netlify Function (Standard, Background, and Scheduled)
     *
     * Owner: erica.pisani@netlify.com
     *
     * @param userId The user's ID.
     * @param properties The event's properties (e.g. functionName)
     * @param options Amplitude event options.
     */
    integrationSentryEnabled(userId, properties, options) {
        return this.track(userId, new IntegrationSentryEnabled(properties), options);
    }
}
export const ampli = new Ampli();
