import { IntegrationHandler } from "@netlify/integrations";
import { captureException, captureMessage, NodeOptions } from "@sentry/serverless";
export type NetlifySentryConfig = {
    cronMonitoring?: {
        enable: boolean;
        monitorId: string;
    };
};
export type SentryConfig = {
    sentry?: NodeOptions & NetlifySentryConfig;
};
export interface SentryContext {
    sentry: {
        captureException: typeof captureException;
        captureMessage: typeof captureMessage;
    };
}
export declare const getNetlifyConfig: (sentryConfig?: SentryConfig["sentry"]) => NetlifySentryConfig;
export declare const startSentryCheckIn: (monitorId: string) => Promise<void>;
export declare const completeSentryCheckIn: (monitorId: string) => Promise<void>;
export declare const withSentry: IntegrationHandler<SentryContext, SentryConfig>;
